<template>
  <transition name="modal-fade">
    <div class="modal-backdrop">
      <div class="modal" :class="{loading: isLoading == true}">
        <slot name="header">
        </slot>
        <slot name="body">
          <!--img :src="this.$logoimg" width="110" style="display:block; margin: 0 auto"/-->
          <swiper :options="swiperOption" ref="mySwiper">
            <!-- slides -->
            <swiper-slide v-for="(drink,index) in filteredDrinks" :key="index"
              :class="{disabled: drink.type == disabledType}" >
              <div class="image-wrapper" :style="{'backgroundImage':'url('+drink.enlarge_image+')'}">
                <!--img :src="drink.image" width="780" class=""-->
              </div>
              <div class="space-sm"></div>
              <!--a class="btn-confirm btn-brand" @click="selectDrink(index)"-->
              <a class="btn-confirm btn-brand" :data-index="index" :data-id="drink.drinkId"
                v-if="drink.type != disabledType">
                确认
              </a>
              <a class="" :data-index="index"
                v-if="drink.type == disabledType">
                领取頧已满
              </a>
            </swiper-slide>
            <!-- Optional controls -->
            <!--div class="swiper-pagination"  slot="pagination"></div-->
            <div class="swiper-button-prev" slot="button-prev"></div>
            <div class="swiper-button-next" slot="button-next"></div>
            <!--div class="swiper-scrollbar"   slot="scrollbar"></div-->
          </swiper>
        </slot>
        <slot name="footer"></slot>
        <a class="btn-close" type="button" @click="close">
          <img :src="ui_cross" width="48" />
        </a>
      </div>
    </div>
  </transition>
</template>

<script>
import 'swiper/dist/css/swiper.css'
import JQuery from 'jquery'

export default {
  name: 'modal',
  props: {
    //id: Number,
    //name: String,
    //image: String,
    count: Number,
    index: Number,
  },
  data () {
    return {
      isLoading: false,
      api: this.getApi(),
      user: this.$config.user,
      ui_cross: require('../assets/ui-cross.png'),
      drinks: this.$config.drinks[this.$config.venue],
      filteredDrinks: this.getValidDrinks(),
      swiperOption: {
        loop: true,
        navigation: {
          nextEl: '.swiper-button-next',
          prevEl: '.swiper-button-prev',
        },
      },
      disabledType: '',
    }
  },
  watch: {
    count: function(newVal, oldVal){
      if(newVal != oldVal){
        this.refresh()
      }
    },
    index: function(newVal, oldVal){
      console.log(newVal)
    }
  },
  methods: {

    getValidDrinks: function(){
      var vm = this;
      var allDrinks = this.$config.drinks[this.$config.venue];
      var filterDrinks = allDrinks.filter( drink => vm.getToday() >= drink.startDate && vm.getToday() <= drink.endDate );
      return filterDrinks;
    },
    getToday() {
      var num;

      function toTwoDigit(myNumber){
        return ("0" + myNumber).slice(-2);
      }

      var yyyy = new Date().getFullYear();
      var mm = toTwoDigit(new Date().getMonth() + 1);
      var dd = toTwoDigit(new Date().getDate());

      var fulldate = yyyy.toString() + mm.toString() + dd.toString();
      num = parseInt(fulldate);

      return num;
    },
    getApi: function(){
      var _venue = this.getCookie("order_hennessy_venue");
      if(_venue == '' || _venue == 'undefined' || _venue  == null){
        this.$router.push('/config') //success -> goto ticket 
        return false;
      }
      return this.$config.api_url[_venue].api_prefix
    },
    getCookie: function(cname) {
        var name = cname + "=";
        var decodedCookie = decodeURIComponent(document.cookie);
        var ca = decodedCookie.split(';');
        for(var i = 0; i <ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') {
                c = c.substring(1);
            }
            if (c.indexOf(name) == 0) {
                return c.substring(name.length, c.length);
            }
        }
        return "";
    },
    close() {
      this.$emit('close');
    },
    getTypeByDrinkId: function(id){
      var drinks = this.$config.drinks[this.$config.venue];
      var drink = drinks.filter(drink => drink.drinkId == id)[0];
      return drink.type;
    },
    selectDrink: function(drinkId){
      var vm = this;
      var submitData = {
        userId: vm.user.userId,
        userName: vm.user.userName,
        drinkId: drinkId
      }
      if( this.$config.venue == 'shanghai' ){
        submitData.stand = vm.$config.stand;
      }else if( this.$config.venue == 'malaysia' ){
        submitData.stand = "";
        drinkType = vm.getTypeByDrinkId(drinkId);
      }

      vm.isLoading = true
      JQuery.post(vm.api + '/api/redeemDrink', submitData)
      .done(function(response){
        console.log(vm.api + '/api/redeemDrink : response: ', response);
        vm.isLoading = false
        var data = response;
        vm.$router.push({ 
          path: '/success',
          query: data,
        })
      })
      .fail(function(){
        vm.isLoading = false
        alert("系统出现错误，请联络我们的服务员")
      })
      /*vm.$axios
      .post(vm.api + '/api/redeemDrink', submitData)
      .then(function(response){
        console.log(vm.api + '/api/redeemDrink : response: ', response);
        var data = response.data;
        vm.$router.push({ 
          path: '/success',
          query: data,
        })
      })
      .catch(function(error){
        console.log(error)
      })*/

      /*var sampleReturn = {
        userId: submitData.userId,
        userName: submitData.userName,
        drinkId: submitData.drinkId,
        orderNumber: '2468',
      }*/
      
    },
    refresh() {
      var vm = this;
      vm.$refs.mySwiper.swiper.update();
      vm.$refs.mySwiper.swiper.slideTo(this.index + 1);	
    },
    evt() {
      var vm = this;
      JQuery("#app").on('click', '.modal .btn-confirm', function(e){
        e.preventDefault();
        var drinkId = JQuery(this).attr('data-id');
        vm.selectDrink(drinkId);
      })
    },
    unbindEvt() {
      JQuery("#app").off('click', '.modal .btn-confirm')
    }
  },
  mounted: function(){
    this.evt()
  },
  beforeDestroy: function(){
    this.unbindEvt()
  }
};
</script>

<style lang="sass">
@import "../styles/modal.sass"
</style>